image: nstwf/php:8.1
stages:
  - build
  - tests
  - tagging

.build: &build
  stage: build
  allow_failure: false
  script:
    - composer install --optimize-autoloader
  cache:
    paths:
      - vendor/

build:
  <<: *build #Merge build template
  only:
    - main
    - dev
    - /^release\/[0-9]*\.[0-9]*\.[0-9]*$/
    - tags
  artifacts:
    expire_in: 1 day
    untracked: true

build_manual:
  <<: *build #Merge build template
  when: manual
  except:
    - main
    - dev
    - /^release\/[0-9]*\.[0-9]*\.[0-9]*$/
    - tags
  artifacts:
    expire_in: 1 day
    untracked: true

tests:
  stage: tests
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'
  script:
    - XDEBUG_MODE=coverage ./vendor/bin/phpunit -c ./ --coverage-text --colors=never --stderr

tagging:
  stage: tagging
  only:
    - main
  script:
    - git config --global user.name "${GITLAB_USER_NAME}"
    - git config --global user.email "${GITLAB_USER_EMAIL}"
    - tag=$(cat composer.json | grep version | grep -Eo "[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+")
    - git tag "$tag"
    - git push --tags https://$CI_DEPLOY_USER:$ACCESS_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git HEAD:main